"""
----------------------v1.0.0----------------------
  ____                 _      _           _       
 / ___| ___   ___   __| | ___| |__   __ _(_)_ __  
| |  _ / _ \ / _ \ / _` |/ __| '_ \ / _` | | '_ \ 
| |_| | (_) | (_) | (_| | (__| | | | (_| | | | | |
 \____|\___/ \___/ \__,_|\___|_| |_|\__,_|_|_| |_|

------------------Ryan & Teuntje------------------
"""
from helpers.DatabaseHelper import DatabaseHelper
from helpers.MenuHelper import MenuHelper
from helpers import UtilityHelper as utilityHelper
from helpers import SocketHelper as socketHelper
import threading
from time import sleep

import os
from dotenv import load_dotenv
load_dotenv()

if __name__ == "__main__":

    port = int(os.getenv("PORT"))
    ip = os.getenv("IP")

    utilityHelper.clearScreen()
    utilityHelper.printLogo()
    # start db connection
    db = DatabaseHelper("../data/goodchain.db")
    db.checkMigrations()

    # check ledger and pool file
    utilityHelper.createFile("../data/ledger.dat")
    utilityHelper.createFile("../data/transaction_pool.dat")

    sleep(1)

    def program():
        # start menu
        menu = MenuHelper(db)

        menu.port = int(os.getenv("PORT"))
        menu.ip_addr = os.getenv("IP")


        menu.peer_port = int(os.getenv("PEER_PORT"))
        menu.peer_ip_addr = os.getenv("PEER_IP")

        while(True):
            menu.runStartMenu()
            
            if menu.user != None:
                menu.runUserMainMenu()
    
    program_thread = threading.Thread(target=program)
    program_thread.start()

    connection_thread = threading.Thread(target=socketHelper.connection, args=(ip,port,db,))
    connection_thread.start()
